/* Check.c generated by valac 0.47.3, the Vala compiler
 * generated from Check.vala, do not modify */

/*
 * Copyright (c) 2016-2019 elementary LLC. (https://github.com/elementary/vala-lint)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Authored by: Marcus Wichelmann <marcus.wichelmann@hotmail.de>
 */

#include <glib-object.h>
#include <valagee.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <vala.h>

#define VALA_LINT_TYPE_CHECK (vala_lint_check_get_type ())
#define VALA_LINT_CHECK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALA_LINT_TYPE_CHECK, ValaLintCheck))
#define VALA_LINT_CHECK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALA_LINT_TYPE_CHECK, ValaLintCheckClass))
#define VALA_LINT_IS_CHECK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALA_LINT_TYPE_CHECK))
#define VALA_LINT_IS_CHECK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALA_LINT_TYPE_CHECK))
#define VALA_LINT_CHECK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALA_LINT_TYPE_CHECK, ValaLintCheckClass))

typedef struct _ValaLintCheck ValaLintCheck;
typedef struct _ValaLintCheckClass ValaLintCheckClass;
typedef struct _ValaLintCheckPrivate ValaLintCheckPrivate;

#define TYPE_PARSE_RESULT (parse_result_get_type ())
typedef struct _ParseResult ParseResult;
typedef enum  {
	PARSE_TYPE_DEFAULT,
	PARSE_TYPE_COMMENT,
	PARSE_TYPE_STRING
} ParseType;

#define TYPE_PARSE_TYPE (parse_type_get_type ())
typedef enum  {
	PARSE_DETAIL_TYPE_INLINE_COMMENT,
	PARSE_DETAIL_TYPE_MULTILINE_COMMENT,
	PARSE_DETAIL_TYPE_VERBATIM_STRING,
	PARSE_DETAIL_TYPE_INTERPOLATED_STRING,
	PARSE_DETAIL_TYPE_NORMAL_STRING,
	PARSE_DETAIL_TYPE_SINGLE_CHAR,
	PARSE_DETAIL_TYPE_CODE
} ParseDetailType;

#define TYPE_PARSE_DETAIL_TYPE (parse_detail_type_get_type ())

#define VALA_LINT_TYPE_FORMAT_MISTAKE (vala_lint_format_mistake_get_type ())
typedef struct _ValaLintFormatMistake ValaLintFormatMistake;
typedef enum  {
	VALA_LINT_CONFIG_STATE_ERROR,
	VALA_LINT_CONFIG_STATE_WARN,
	VALA_LINT_CONFIG_STATE_OFF
} ValaLintConfigState;

#define VALA_LINT_CONFIG_TYPE_STATE (vala_lint_config_state_get_type ())
enum  {
	VALA_LINT_CHECK_0_PROPERTY,
	VALA_LINT_CHECK_SINGLE_MISTAKE_IN_LINE_PROPERTY,
	VALA_LINT_CHECK_TITLE_PROPERTY,
	VALA_LINT_CHECK_DESCRIPTION_PROPERTY,
	VALA_LINT_CHECK_STATE_PROPERTY,
	VALA_LINT_CHECK_NUM_PROPERTIES
};
static GParamSpec* vala_lint_check_properties[VALA_LINT_CHECK_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_match_info_unref0(var) ((var == NULL) ? NULL : (var = (g_match_info_unref (var), NULL)))
#define _vala_lint_format_mistake_free0(var) ((var == NULL) ? NULL : (var = (vala_lint_format_mistake_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

struct _ParseResult {
	gchar* text;
	ParseType type;
	ParseDetailType detail_type;
	ValaSourceLocation begin;
};

struct _ValaLintFormatMistake {
	ValaLintCheck* check;
	ValaSourceLocation begin;
	ValaSourceLocation end;
	gchar* mistake;
};

struct _ValaLintCheck {
	GObject parent_instance;
	ValaLintCheckPrivate * priv;
};

struct _ValaLintCheckClass {
	GObjectClass parent_class;
	void (*check) (ValaLintCheck* self, ValaArrayList* parse_result, ValaArrayList* * mistake_list);
};

struct _ValaLintCheckPrivate {
	gboolean _single_mistake_in_line;
	gchar* _title;
	gchar* _description;
	ValaLintConfigState _state;
};

static gint ValaLintCheck_private_offset;
static gpointer vala_lint_check_parent_class = NULL;

GType vala_lint_check_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ValaLintCheck, g_object_unref)
GType parse_result_get_type (void) G_GNUC_CONST;
GType parse_type_get_type (void) G_GNUC_CONST;
GType parse_detail_type_get_type (void) G_GNUC_CONST;
ParseResult* parse_result_dup (const ParseResult* self);
void parse_result_free (ParseResult* self);
void parse_result_copy (const ParseResult* self,
                        ParseResult* dest);
void parse_result_destroy (ParseResult* self);
GType vala_lint_format_mistake_get_type (void) G_GNUC_CONST;
ValaLintFormatMistake* vala_lint_format_mistake_dup (const ValaLintFormatMistake* self);
void vala_lint_format_mistake_free (ValaLintFormatMistake* self);
void vala_lint_format_mistake_copy (const ValaLintFormatMistake* self,
                                    ValaLintFormatMistake* dest);
void vala_lint_format_mistake_destroy (ValaLintFormatMistake* self);
GType vala_lint_config_state_get_type (void) G_GNUC_CONST;
void vala_lint_check_check (ValaLintCheck* self,
                            ValaArrayList* parse_result,
                            ValaArrayList* * mistake_list);
static void vala_lint_check_real_check (ValaLintCheck* self,
                                 ValaArrayList* parse_result,
                                 ValaArrayList* * mistake_list);
void vala_lint_check_add_regex_mistake (ValaLintCheck* self,
                                        const gchar* pattern,
                                        const gchar* mistake,
                                        ParseResult* parse_result,
                                        ValaArrayList* * mistakes,
                                        gint length,
                                        gint column_offset,
                                        gboolean return_after_mistake);
void vala_lint_utils_get_absolute_location (ValaSourceLocation* reference,
                                            const gchar* text,
                                            gint offset,
                                            ValaSourceLocation* result);
gboolean vala_lint_check_get_single_mistake_in_line (ValaLintCheck* self);
void vala_lint_check_add_mistake (ValaLintCheck* self,
                                  ValaLintFormatMistake* mistake,
                                  ValaArrayList* * mistakes);
ValaLintCheck* vala_lint_check_construct (GType object_type);
static void vala_lint_check_set_single_mistake_in_line (ValaLintCheck* self,
                                                 gboolean value);
const gchar* vala_lint_check_get_title (ValaLintCheck* self);
static void vala_lint_check_set_title (ValaLintCheck* self,
                                const gchar* value);
const gchar* vala_lint_check_get_description (ValaLintCheck* self);
static void vala_lint_check_set_description (ValaLintCheck* self,
                                      const gchar* value);
ValaLintConfigState vala_lint_check_get_state (ValaLintCheck* self);
void vala_lint_check_set_state (ValaLintCheck* self,
                                ValaLintConfigState value);
static void vala_lint_check_finalize (GObject * obj);
static GType vala_lint_check_get_type_once (void);
static void _vala_vala_lint_check_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_vala_lint_check_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);

static inline gpointer
vala_lint_check_get_instance_private (ValaLintCheck* self)
{
	return G_STRUCT_MEMBER_P (self, ValaLintCheck_private_offset);
}

/**
     * Checks a given parse result for formatting mistakes.
     *
     * @param parse_result The parsed string.
     * @param mistake_list The list new mistakes should be added to.
     */
static void
vala_lint_check_real_check (ValaLintCheck* self,
                            ValaArrayList* parse_result,
                            ValaArrayList* * mistake_list)
{
	g_critical ("Type `%s' does not implement abstract method `vala_lint_check_check'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}

void
vala_lint_check_check (ValaLintCheck* self,
                       ValaArrayList* parse_result,
                       ValaArrayList* * mistake_list)
{
	g_return_if_fail (self != NULL);
	VALA_LINT_CHECK_GET_CLASS (self)->check (self, parse_result, mistake_list);
}

/**
     * Adds a mistake based on a regex pattern.
     *
     * @param pattern The regex pattern.
     * @param mistake The mistake description.
     * @param parse_result The current parse result element.
     * @param mistakes The mistakes list.
     * @param column_offset The offset between the mistake char position and the regex pattern start.
     */
void
vala_lint_check_add_regex_mistake (ValaLintCheck* self,
                                   const gchar* pattern,
                                   const gchar* mistake,
                                   ParseResult* parse_result,
                                   ValaArrayList* * mistakes,
                                   gint length,
                                   gint column_offset,
                                   gboolean return_after_mistake)
{
	GMatchInfo* match_info = NULL;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (pattern != NULL);
	g_return_if_fail (mistake != NULL);
	g_return_if_fail (parse_result != NULL);
	g_return_if_fail (*mistakes != NULL);
	{
		GRegex* regex = NULL;
		GRegex* _tmp0_;
		GRegex* _tmp1_;
		ParseResult _tmp2_;
		const gchar* _tmp3_;
		GMatchInfo* _tmp4_ = NULL;
		_tmp0_ = g_regex_new (pattern, 0, 0, &_inner_error0_);
		regex = _tmp0_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp1_ = regex;
		_tmp2_ = *parse_result;
		_tmp3_ = _tmp2_.text;
		g_regex_match (_tmp1_, _tmp3_, 0, &_tmp4_);
		_g_match_info_unref0 (match_info);
		match_info = _tmp4_;
		while (TRUE) {
			GMatchInfo* _tmp5_;
			gint pos_start = 0;
			gint pos_end = 0;
			GMatchInfo* _tmp6_;
			gint _tmp7_ = 0;
			gint _tmp8_ = 0;
			gint pos_mistake = 0;
			ValaSourceLocation begin = {0};
			ParseResult _tmp9_;
			ValaSourceLocation _tmp10_;
			ParseResult _tmp11_;
			const gchar* _tmp12_;
			ValaSourceLocation _tmp13_ = {0};
			ValaSourceLocation end = {0};
			ParseResult _tmp14_;
			ValaSourceLocation _tmp15_;
			ParseResult _tmp16_;
			const gchar* _tmp17_;
			ValaSourceLocation _tmp18_ = {0};
			gboolean _tmp19_ = FALSE;
			gboolean _tmp20_;
			GMatchInfo* _tmp35_;
			_tmp5_ = match_info;
			if (!g_match_info_matches (_tmp5_)) {
				break;
			}
			_tmp6_ = match_info;
			g_match_info_fetch_pos (_tmp6_, 0, &_tmp7_, &_tmp8_);
			pos_start = _tmp7_;
			pos_end = _tmp8_;
			pos_mistake = pos_start + column_offset;
			_tmp9_ = *parse_result;
			_tmp10_ = _tmp9_.begin;
			_tmp11_ = *parse_result;
			_tmp12_ = _tmp11_.text;
			vala_lint_utils_get_absolute_location (&_tmp10_, _tmp12_, pos_mistake, &_tmp13_);
			begin = _tmp13_;
			_tmp14_ = *parse_result;
			_tmp15_ = _tmp14_.begin;
			_tmp16_ = *parse_result;
			_tmp17_ = _tmp16_.text;
			vala_lint_utils_get_absolute_location (&_tmp15_, _tmp17_, pos_mistake + length, &_tmp18_);
			end = _tmp18_;
			_tmp20_ = self->priv->_single_mistake_in_line;
			if (!_tmp20_) {
				_tmp19_ = TRUE;
			} else {
				gboolean _tmp21_ = FALSE;
				gboolean _tmp22_ = FALSE;
				gboolean _tmp23_;
				gboolean _tmp24_;
				_tmp23_ = vala_collection_get_is_empty ((ValaCollection*) (*mistakes));
				_tmp24_ = _tmp23_;
				if (_tmp24_) {
					_tmp22_ = TRUE;
				} else {
					gpointer _tmp25_;
					ValaLintFormatMistake* _tmp26_;
					ValaLintCheck* _tmp27_;
					_tmp25_ = vala_list_last ((ValaList*) (*mistakes));
					_tmp26_ = (ValaLintFormatMistake*) _tmp25_;
					_tmp27_ = (*_tmp26_).check;
					_tmp22_ = _tmp27_ != self;
					_vala_lint_format_mistake_free0 (_tmp26_);
				}
				if (_tmp22_) {
					_tmp21_ = TRUE;
				} else {
					gpointer _tmp28_;
					ValaLintFormatMistake* _tmp29_;
					ValaSourceLocation _tmp30_;
					ValaSourceLocation _tmp31_;
					_tmp28_ = vala_list_last ((ValaList*) (*mistakes));
					_tmp29_ = (ValaLintFormatMistake*) _tmp28_;
					_tmp30_ = (*_tmp29_).begin;
					_tmp31_ = begin;
					_tmp21_ = _tmp30_.line < _tmp31_.line;
					_vala_lint_format_mistake_free0 (_tmp29_);
				}
				_tmp19_ = _tmp21_;
			}
			if (_tmp19_) {
				ValaSourceLocation _tmp32_;
				ValaSourceLocation _tmp33_;
				ValaLintFormatMistake _tmp34_ = {0};
				_tmp32_ = begin;
				_tmp33_ = end;
				_g_object_unref0 (_tmp34_.check);
				_tmp34_.check = self;
				_tmp34_.begin = _tmp32_;
				_tmp34_.end = _tmp33_;
				_g_free0 (_tmp34_.mistake);
				_tmp34_.mistake = mistake;
				vala_lint_check_add_mistake (self, &_tmp34_, mistakes);
			}
			if (return_after_mistake) {
				break;
			}
			_tmp35_ = match_info;
			g_match_info_next (_tmp35_, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_regex_unref0 (regex);
				goto __catch0_g_error;
			}
		}
		_g_regex_unref0 (regex);
	}
	goto __finally0;
	__catch0_g_error:
	{
		g_clear_error (&_inner_error0_);
		_inner_error0_ = NULL;
		g_critical ("Check.vala:96: %s is not a valid Regex", pattern);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_match_info_unref0 (match_info);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_g_match_info_unref0 (match_info);
}

/**
     * Adds a mistake to the mistake list and checks for duplicates.
     *
     * @param mistake The mistake.
     * @param mistakes The mistakes list.
     */
void
vala_lint_check_add_mistake (ValaLintCheck* self,
                             ValaLintFormatMistake* mistake,
                             ValaArrayList* * mistakes)
{
	ValaLintFormatMistake _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (mistake != NULL);
	g_return_if_fail (*mistakes != NULL);
	_tmp0_ = *mistake;
	if (!vala_collection_contains ((ValaCollection*) (*mistakes), &_tmp0_)) {
		ValaLintFormatMistake _tmp1_;
		_tmp1_ = *mistake;
		vala_collection_add ((ValaCollection*) (*mistakes), &_tmp1_);
	}
}

ValaLintCheck*
vala_lint_check_construct (GType object_type)
{
	ValaLintCheck * self = NULL;
	self = (ValaLintCheck*) g_object_new (object_type, NULL);
	return self;
}

gboolean
vala_lint_check_get_single_mistake_in_line (ValaLintCheck* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_single_mistake_in_line;
	return result;
}

static void
vala_lint_check_set_single_mistake_in_line (ValaLintCheck* self,
                                            gboolean value)
{
	g_return_if_fail (self != NULL);
	if (vala_lint_check_get_single_mistake_in_line (self) != value) {
		self->priv->_single_mistake_in_line = value;
		g_object_notify_by_pspec ((GObject *) self, vala_lint_check_properties[VALA_LINT_CHECK_SINGLE_MISTAKE_IN_LINE_PROPERTY]);
	}
}

const gchar*
vala_lint_check_get_title (ValaLintCheck* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_title;
	result = _tmp0_;
	return result;
}

static void
vala_lint_check_set_title (ValaLintCheck* self,
                           const gchar* value)
{
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, vala_lint_check_get_title (self)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_title);
		self->priv->_title = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, vala_lint_check_properties[VALA_LINT_CHECK_TITLE_PROPERTY]);
	}
}

const gchar*
vala_lint_check_get_description (ValaLintCheck* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_description;
	result = _tmp0_;
	return result;
}

static void
vala_lint_check_set_description (ValaLintCheck* self,
                                 const gchar* value)
{
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, vala_lint_check_get_description (self)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_description);
		self->priv->_description = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, vala_lint_check_properties[VALA_LINT_CHECK_DESCRIPTION_PROPERTY]);
	}
}

ValaLintConfigState
vala_lint_check_get_state (ValaLintCheck* self)
{
	ValaLintConfigState result;
	ValaLintConfigState _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_state;
	result = _tmp0_;
	return result;
}

void
vala_lint_check_set_state (ValaLintCheck* self,
                           ValaLintConfigState value)
{
	g_return_if_fail (self != NULL);
	if (vala_lint_check_get_state (self) != value) {
		self->priv->_state = value;
		g_object_notify_by_pspec ((GObject *) self, vala_lint_check_properties[VALA_LINT_CHECK_STATE_PROPERTY]);
	}
}

static void
vala_lint_check_class_init (ValaLintCheckClass * klass,
                            gpointer klass_data)
{
	vala_lint_check_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &ValaLintCheck_private_offset);
	((ValaLintCheckClass *) klass)->check = (void (*) (ValaLintCheck*, ValaArrayList*, ValaArrayList* *)) vala_lint_check_real_check;
	G_OBJECT_CLASS (klass)->get_property = _vala_vala_lint_check_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_vala_lint_check_set_property;
	G_OBJECT_CLASS (klass)->finalize = vala_lint_check_finalize;
	/**
	     * Property whether the check should allow multiple mistakes in a single line.
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALA_LINT_CHECK_SINGLE_MISTAKE_IN_LINE_PROPERTY, vala_lint_check_properties[VALA_LINT_CHECK_SINGLE_MISTAKE_IN_LINE_PROPERTY] = g_param_spec_boolean ("single-mistake-in-line", "single-mistake-in-line", "single-mistake-in-line", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	/**
	     * Short but descriptive title of the check.
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALA_LINT_CHECK_TITLE_PROPERTY, vala_lint_check_properties[VALA_LINT_CHECK_TITLE_PROPERTY] = g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	/**
	     * A short description of what this class checks for.
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALA_LINT_CHECK_DESCRIPTION_PROPERTY, vala_lint_check_properties[VALA_LINT_CHECK_DESCRIPTION_PROPERTY] = g_param_spec_string ("description", "description", "description", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	/**
	     * Property whether the check is enabled in the current linter config.
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALA_LINT_CHECK_STATE_PROPERTY, vala_lint_check_properties[VALA_LINT_CHECK_STATE_PROPERTY] = g_param_spec_enum ("state", "state", "state", VALA_LINT_CONFIG_TYPE_STATE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
vala_lint_check_instance_init (ValaLintCheck * self,
                               gpointer klass)
{
	self->priv = vala_lint_check_get_instance_private (self);
	self->priv->_single_mistake_in_line = FALSE;
}

static void
vala_lint_check_finalize (GObject * obj)
{
	ValaLintCheck * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VALA_LINT_TYPE_CHECK, ValaLintCheck);
	_g_free0 (self->priv->_title);
	_g_free0 (self->priv->_description);
	G_OBJECT_CLASS (vala_lint_check_parent_class)->finalize (obj);
}

static GType
vala_lint_check_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ValaLintCheckClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vala_lint_check_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValaLintCheck), 0, (GInstanceInitFunc) vala_lint_check_instance_init, NULL };
	GType vala_lint_check_type_id;
	vala_lint_check_type_id = g_type_register_static (G_TYPE_OBJECT, "ValaLintCheck", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	ValaLintCheck_private_offset = g_type_add_instance_private (vala_lint_check_type_id, sizeof (ValaLintCheckPrivate));
	return vala_lint_check_type_id;
}

GType
vala_lint_check_get_type (void)
{
	static volatile gsize vala_lint_check_type_id__volatile = 0;
	if (g_once_init_enter (&vala_lint_check_type_id__volatile)) {
		GType vala_lint_check_type_id;
		vala_lint_check_type_id = vala_lint_check_get_type_once ();
		g_once_init_leave (&vala_lint_check_type_id__volatile, vala_lint_check_type_id);
	}
	return vala_lint_check_type_id__volatile;
}

static void
_vala_vala_lint_check_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	ValaLintCheck * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VALA_LINT_TYPE_CHECK, ValaLintCheck);
	switch (property_id) {
		case VALA_LINT_CHECK_SINGLE_MISTAKE_IN_LINE_PROPERTY:
		g_value_set_boolean (value, vala_lint_check_get_single_mistake_in_line (self));
		break;
		case VALA_LINT_CHECK_TITLE_PROPERTY:
		g_value_set_string (value, vala_lint_check_get_title (self));
		break;
		case VALA_LINT_CHECK_DESCRIPTION_PROPERTY:
		g_value_set_string (value, vala_lint_check_get_description (self));
		break;
		case VALA_LINT_CHECK_STATE_PROPERTY:
		g_value_set_enum (value, vala_lint_check_get_state (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_vala_lint_check_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	ValaLintCheck * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VALA_LINT_TYPE_CHECK, ValaLintCheck);
	switch (property_id) {
		case VALA_LINT_CHECK_SINGLE_MISTAKE_IN_LINE_PROPERTY:
		vala_lint_check_set_single_mistake_in_line (self, g_value_get_boolean (value));
		break;
		case VALA_LINT_CHECK_TITLE_PROPERTY:
		vala_lint_check_set_title (self, g_value_get_string (value));
		break;
		case VALA_LINT_CHECK_DESCRIPTION_PROPERTY:
		vala_lint_check_set_description (self, g_value_get_string (value));
		break;
		case VALA_LINT_CHECK_STATE_PROPERTY:
		vala_lint_check_set_state (self, g_value_get_enum (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

