/* ParseResult.c generated by valac 0.47.3, the Vala compiler
 * generated from ParseResult.vala, do not modify */

/*
 * Copyright (c) 2018-2019 elementary LLC. (https://github.com/elementary/Vala-Lint)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <vala.h>

typedef enum  {
	PARSE_TYPE_DEFAULT,
	PARSE_TYPE_COMMENT,
	PARSE_TYPE_STRING
} ParseType;

#define TYPE_PARSE_TYPE (parse_type_get_type ())
typedef enum  {
	PARSE_DETAIL_TYPE_INLINE_COMMENT,
	PARSE_DETAIL_TYPE_MULTILINE_COMMENT,
	PARSE_DETAIL_TYPE_VERBATIM_STRING,
	PARSE_DETAIL_TYPE_INTERPOLATED_STRING,
	PARSE_DETAIL_TYPE_NORMAL_STRING,
	PARSE_DETAIL_TYPE_SINGLE_CHAR,
	PARSE_DETAIL_TYPE_CODE
} ParseDetailType;

#define TYPE_PARSE_DETAIL_TYPE (parse_detail_type_get_type ())

#define TYPE_PARSE_RESULT (parse_result_get_type ())
typedef struct _ParseResult ParseResult;
#define _g_free0(var) (var = (g_free (var), NULL))

struct _ParseResult {
	gchar* text;
	ParseType type;
	ParseDetailType detail_type;
	ValaSourceLocation begin;
};

GType parse_type_get_type (void) G_GNUC_CONST;
GType parse_detail_type_get_type (void) G_GNUC_CONST;
GType parse_result_get_type (void) G_GNUC_CONST;
ParseResult* parse_result_dup (const ParseResult* self);
void parse_result_free (ParseResult* self);
void parse_result_copy (const ParseResult* self,
                        ParseResult* dest);
void parse_result_destroy (ParseResult* self);

static GType
parse_type_get_type_once (void)
{
	static const GEnumValue values[] = {{PARSE_TYPE_DEFAULT, "PARSE_TYPE_DEFAULT", "default"}, {PARSE_TYPE_COMMENT, "PARSE_TYPE_COMMENT", "comment"}, {PARSE_TYPE_STRING, "PARSE_TYPE_STRING", "string"}, {0, NULL, NULL}};
	GType parse_type_type_id;
	parse_type_type_id = g_enum_register_static ("ParseType", values);
	return parse_type_type_id;
}

GType
parse_type_get_type (void)
{
	static volatile gsize parse_type_type_id__volatile = 0;
	if (g_once_init_enter (&parse_type_type_id__volatile)) {
		GType parse_type_type_id;
		parse_type_type_id = parse_type_get_type_once ();
		g_once_init_leave (&parse_type_type_id__volatile, parse_type_type_id);
	}
	return parse_type_type_id__volatile;
}

static GType
parse_detail_type_get_type_once (void)
{
	static const GEnumValue values[] = {{PARSE_DETAIL_TYPE_INLINE_COMMENT, "PARSE_DETAIL_TYPE_INLINE_COMMENT", "inline-comment"}, {PARSE_DETAIL_TYPE_MULTILINE_COMMENT, "PARSE_DETAIL_TYPE_MULTILINE_COMMENT", "multiline-comment"}, {PARSE_DETAIL_TYPE_VERBATIM_STRING, "PARSE_DETAIL_TYPE_VERBATIM_STRING", "verbatim-string"}, {PARSE_DETAIL_TYPE_INTERPOLATED_STRING, "PARSE_DETAIL_TYPE_INTERPOLATED_STRING", "interpolated-string"}, {PARSE_DETAIL_TYPE_NORMAL_STRING, "PARSE_DETAIL_TYPE_NORMAL_STRING", "normal-string"}, {PARSE_DETAIL_TYPE_SINGLE_CHAR, "PARSE_DETAIL_TYPE_SINGLE_CHAR", "single-char"}, {PARSE_DETAIL_TYPE_CODE, "PARSE_DETAIL_TYPE_CODE", "code"}, {0, NULL, NULL}};
	GType parse_detail_type_type_id;
	parse_detail_type_type_id = g_enum_register_static ("ParseDetailType", values);
	return parse_detail_type_type_id;
}

GType
parse_detail_type_get_type (void)
{
	static volatile gsize parse_detail_type_type_id__volatile = 0;
	if (g_once_init_enter (&parse_detail_type_type_id__volatile)) {
		GType parse_detail_type_type_id;
		parse_detail_type_type_id = parse_detail_type_get_type_once ();
		g_once_init_leave (&parse_detail_type_type_id__volatile, parse_detail_type_type_id);
	}
	return parse_detail_type_type_id__volatile;
}

void
parse_result_copy (const ParseResult* self,
                   ParseResult* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	ParseType _tmp2_;
	ParseDetailType _tmp3_;
	ValaSourceLocation _tmp4_;
	_tmp0_ = (*self).text;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 ((*dest).text);
	(*dest).text = _tmp1_;
	_tmp2_ = (*self).type;
	(*dest).type = _tmp2_;
	_tmp3_ = (*self).detail_type;
	(*dest).detail_type = _tmp3_;
	_tmp4_ = (*self).begin;
	(*dest).begin = _tmp4_;
}

void
parse_result_destroy (ParseResult* self)
{
	_g_free0 ((*self).text);
}

ParseResult*
parse_result_dup (const ParseResult* self)
{
	ParseResult* dup;
	dup = g_new0 (ParseResult, 1);
	parse_result_copy (self, dup);
	return dup;
}

void
parse_result_free (ParseResult* self)
{
	parse_result_destroy (self);
	g_free (self);
}

static GType
parse_result_get_type_once (void)
{
	GType parse_result_type_id;
	parse_result_type_id = g_boxed_type_register_static ("ParseResult", (GBoxedCopyFunc) parse_result_dup, (GBoxedFreeFunc) parse_result_free);
	return parse_result_type_id;
}

GType
parse_result_get_type (void)
{
	static volatile gsize parse_result_type_id__volatile = 0;
	if (g_once_init_enter (&parse_result_type_id__volatile)) {
		GType parse_result_type_id;
		parse_result_type_id = parse_result_get_type_once ();
		g_once_init_leave (&parse_result_type_id__volatile, parse_result_type_id);
	}
	return parse_result_type_id__volatile;
}

