/* Application.c generated by valac 0.47.3, the Vala compiler
 * generated from Application.vala, do not modify */

/*
 * Copyright (c) 2016-2019 elementary LLC. (https://github.com/elementary/vala-lint)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Authored by: Marcus Wichelmann <marcus.wichelmann@hotmail.de>
 */

#include <gio/gio.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include "vala-linter-1.0.h"
#include <valagee.h>
#include <glob.h>

#define VALA_LINT_TYPE_APPLICATION (vala_lint_application_get_type ())
#define VALA_LINT_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALA_LINT_TYPE_APPLICATION, ValaLintApplication))
#define VALA_LINT_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALA_LINT_TYPE_APPLICATION, ValaLintApplicationClass))
#define VALA_LINT_IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALA_LINT_TYPE_APPLICATION))
#define VALA_LINT_IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALA_LINT_TYPE_APPLICATION))
#define VALA_LINT_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALA_LINT_TYPE_APPLICATION, ValaLintApplicationClass))

typedef struct _ValaLintApplication ValaLintApplication;
typedef struct _ValaLintApplicationClass ValaLintApplicationClass;
typedef struct _ValaLintApplicationPrivate ValaLintApplicationPrivate;
enum  {
	VALA_LINT_APPLICATION_0_PROPERTY,
	VALA_LINT_APPLICATION_NUM_PROPERTIES
};
static GParamSpec* vala_lint_application_properties[VALA_LINT_APPLICATION_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_option_context_free0(var) ((var == NULL) ? NULL : (var = (g_option_context_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))

#define VALA_LINT_TYPE_FILE_DATA (vala_lint_file_data_get_type ())
typedef struct _ValaLintFileData ValaLintFileData;
#define _vala_iterable_unref0(var) ((var == NULL) ? NULL : (var = (vala_iterable_unref (var), NULL)))
#define _vala_lint_file_data_free0(var) ((var == NULL) ? NULL : (var = (vala_lint_file_data_free (var), NULL)))
#define __vala_ValaLintFormatMistake_free0(var) ((var == NULL) ? NULL : (var = (_vala_ValaLintFormatMistake_free (var), NULL)))

struct _ValaLintApplication {
	GApplication parent_instance;
	ValaLintApplicationPrivate * priv;
};

struct _ValaLintApplicationClass {
	GApplicationClass parent_class;
};

struct _ValaLintApplicationPrivate {
	GApplicationCommandLine* application_command_line;
};

struct _ValaLintFileData {
	GFile* file;
	gchar* name;
	ValaArrayList* mistakes;
};

static gint ValaLintApplication_private_offset;
static gpointer vala_lint_application_parent_class = NULL;
static gboolean vala_lint_application_print_version;
static gchar* vala_lint_application_lint_directory;
static gboolean vala_lint_application_print_mistakes_end;
static gchar* vala_lint_application_config_file;
static gboolean vala_lint_application_exit_with_zero;
static gboolean vala_lint_application_generate_config_file;
static gchar* vala_lint_application_lint_directory = NULL;
static gboolean vala_lint_application_print_version = FALSE;
static gboolean vala_lint_application_print_mistakes_end = FALSE;
static gboolean vala_lint_application_exit_with_zero = FALSE;
static gboolean vala_lint_application_generate_config_file = FALSE;
static gchar* vala_lint_application_config_file = NULL;

GType vala_lint_application_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ValaLintApplication, g_object_unref)
#define VALA_LINT_APPLICATION_VERSION "0.1"
static ValaLintApplication* vala_lint_application_new (void);
static ValaLintApplication* vala_lint_application_construct (GType object_type);
static gint vala_lint_application_real_command_line (GApplication* base,
                                              GApplicationCommandLine* command_line);
static gint vala_lint_application_handle_command_line (ValaLintApplication* self,
                                                GApplicationCommandLine* command_line);
GType vala_lint_file_data_get_type (void) G_GNUC_CONST;
ValaLintFileData* vala_lint_file_data_dup (const ValaLintFileData* self);
void vala_lint_file_data_free (ValaLintFileData* self);
void vala_lint_file_data_copy (const ValaLintFileData* self,
                               ValaLintFileData* dest);
void vala_lint_file_data_destroy (ValaLintFileData* self);
static ValaArrayList* vala_lint_application_get_files (ValaLintApplication* self,
                                                GApplicationCommandLine* command_line,
                                                gchar** patterns,
                                                gint patterns_length1,
                                                GError** error);
static void vala_lint_application_print_mistakes (ValaLintApplication* self,
                                           ValaArrayList* file_data_list);
static void _vala_ValaLintFormatMistake_free (ValaLintFormatMistake* self);
static ValaLintFormatMistake* _vala_lint_format_mistake_dup (ValaLintFormatMistake* self);
static ValaArrayList* vala_lint_application_get_files_from_directory (ValaLintApplication* self,
                                                               GFile* dir,
                                                               GError** error);
gint vala_lint_application_main (gchar** args,
                                 gint args_length1);
static void vala_lint_application_finalize (GObject * obj);
static GType vala_lint_application_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

static const GOptionEntry VALA_LINT_APPLICATION_OPTIONS[7] = {{"version", 'v', 0, G_OPTION_ARG_NONE, &vala_lint_application_print_version, "Display version number."}, {"directory", 'd', 1, G_OPTION_ARG_STRING, &vala_lint_application_lint_directory, "Lint all Vala files in the given directory. (DEPRECEATED)"}, {"print-end", 'e', 0, G_OPTION_ARG_NONE, &vala_lint_application_print_mistakes_end, "Show end of mistakes."}, {"config", 'c', 0, G_OPTION_ARG_STRING, &vala_lint_application_config_file, "Specify a configuration file."}, {"exit-zero", 'z', 0, G_OPTION_ARG_NONE, &vala_lint_application_exit_with_zero, "Always return a 0 (non-error) status code, even if lint errors are fou" \
"nd."}, {"generate-config", 'g', 0, G_OPTION_ARG_NONE, &vala_lint_application_generate_config_file, "Generate a sample configuration file with default values."}, {NULL}};

static inline gpointer
vala_lint_application_get_instance_private (ValaLintApplication* self)
{
	return G_STRUCT_MEMBER_P (self, ValaLintApplication_private_offset);
}

static ValaLintApplication*
vala_lint_application_construct (GType object_type)
{
	ValaLintApplication * self = NULL;
	self = (ValaLintApplication*) g_object_new (object_type, "application-id", "io.elementary.vala-lint", "flags", G_APPLICATION_HANDLES_COMMAND_LINE, NULL);
	return self;
}

static ValaLintApplication*
vala_lint_application_new (void)
{
	return vala_lint_application_construct (VALA_LINT_TYPE_APPLICATION);
}

static gint
vala_lint_application_real_command_line (GApplication* base,
                                         GApplicationCommandLine* command_line)
{
	ValaLintApplication * self;
	gint res = 0;
	gint result = 0;
	self = (ValaLintApplication*) base;
	g_return_val_if_fail (command_line != NULL, 0);
	g_application_hold ((GApplication*) self);
	res = vala_lint_application_handle_command_line (self, command_line);
	g_application_release ((GApplication*) self);
	result = res;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static gpointer
_vala_iterable_ref0 (gpointer self)
{
	return self ? vala_iterable_ref (self) : NULL;
}

static void
_vala_ValaLintFormatMistake_free (ValaLintFormatMistake* self)
{
	vala_lint_format_mistake_destroy (self);
	g_free (self);
}

static gint
vala_lint_application_handle_command_line (ValaLintApplication* self,
                                           GApplicationCommandLine* command_line)
{
	gchar** args = NULL;
	gint _tmp0_ = 0;
	gchar** _tmp1_;
	gint args_length1;
	gint _args_size_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gchar** tmp = NULL;
	gchar** _tmp8_;
	gint _tmp8__length1;
	gint tmp_length1;
	gint _tmp_size_;
	const gchar* _tmp29_;
	GApplicationCommandLine* _tmp36_;
	ValaArrayList* file_data_list = NULL;
	GEqualFunc _tmp37_;
	ValaArrayList* _tmp38_;
	const gchar* _tmp49_;
	ValaLintLinter* linter = NULL;
	ValaLintLinter* _tmp50_;
	ValaArrayList* _tmp78_;
	GError* _inner_error0_ = NULL;
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (command_line != NULL, 0);
	_tmp1_ = g_application_command_line_get_arguments (command_line, &_tmp0_);
	args = _tmp1_;
	args_length1 = _tmp0_;
	_args_size_ = args_length1;
	_tmp2_ = args;
	_tmp2__length1 = args_length1;
	if (_tmp2__length1 == 1) {
		gchar** _tmp3_;
		gint _tmp3__length1;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar** _tmp7_;
		_tmp3_ = args;
		_tmp3__length1 = args_length1;
		_tmp4_ = _tmp3_[0];
		_tmp5_ = g_strdup (_tmp4_);
		_tmp6_ = g_strdup (".");
		_tmp7_ = g_new0 (gchar*, 2 + 1);
		_tmp7_[0] = _tmp5_;
		_tmp7_[1] = _tmp6_;
		args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
		args = _tmp7_;
		args_length1 = 2;
		_args_size_ = args_length1;
	}
	_tmp8_ = args;
	_tmp8__length1 = args_length1;
	tmp = _tmp8_;
	tmp_length1 = _tmp8__length1;
	_tmp_size_ = tmp_length1;
	{
		GOptionContext* option_context = NULL;
		GOptionContext* _tmp9_;
		GOptionContext* _tmp10_;
		GOptionContext* _tmp11_;
		GOptionContext* _tmp12_;
		_tmp9_ = g_option_context_new ("- Vala-Lint");
		option_context = _tmp9_;
		_tmp10_ = option_context;
		g_option_context_set_help_enabled (_tmp10_, TRUE);
		_tmp11_ = option_context;
		g_option_context_add_main_entries (_tmp11_, VALA_LINT_APPLICATION_OPTIONS, NULL);
		_tmp12_ = option_context;
		g_option_context_parse (_tmp12_, (gint*) (&tmp_length1), &tmp, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			gint _tmp13_ = -1;
			_g_option_context_free0 (option_context);
			if (_inner_error0_->domain == G_OPTION_ERROR) {
				goto __catch0_g_option_error;
			}
			args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp13_;
		}
		_g_option_context_free0 (option_context);
	}
	goto __finally0;
	__catch0_g_option_error:
	{
		GError* e = NULL;
		gchar* _tmp14_;
		gchar* _tmp15_;
		GError* _tmp16_;
		const gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar** _tmp20_;
		gint _tmp20__length1;
		const gchar* _tmp21_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp14_ = g_strconcat (_ ("Error: %s"), "\n", NULL);
		_tmp15_ = _tmp14_;
		_tmp16_ = e;
		_tmp17_ = _tmp16_->message;
		g_application_command_line_print (command_line, _tmp15_, _tmp17_);
		_g_free0 (_tmp15_);
		_tmp18_ = g_strconcat (_ ("Run '%s --help' to see a full list of available options."), "\n", NULL);
		_tmp19_ = _tmp18_;
		_tmp20_ = args;
		_tmp20__length1 = args_length1;
		_tmp21_ = _tmp20_[0];
		g_application_command_line_print (command_line, _tmp19_, _tmp21_);
		_g_free0 (_tmp19_);
		result = 1;
		_g_error_free0 (e);
		args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
		return result;
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gint _tmp22_ = -1;
		args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp22_;
	}
	if (vala_lint_application_print_version) {
		gchar* _tmp23_;
		gchar* _tmp24_;
		_tmp23_ = g_strconcat (_ ("Version: %s"), "\n", NULL);
		_tmp24_ = _tmp23_;
		g_application_command_line_print (command_line, _tmp24_, VALA_LINT_APPLICATION_VERSION);
		_g_free0 (_tmp24_);
		result = 0;
		args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
		return result;
	}
	if (vala_lint_application_generate_config_file) {
		GKeyFile* default_config = NULL;
		GKeyFile* _tmp25_;
		GKeyFile* _tmp26_;
		gchar* _tmp27_;
		gchar* _tmp28_;
		_tmp25_ = vala_lint_config_get_default_config ();
		default_config = _tmp25_;
		_tmp26_ = default_config;
		_tmp27_ = g_key_file_to_data (_tmp26_, NULL, NULL);
		_tmp28_ = _tmp27_;
		g_application_command_line_print (command_line, "%s", _tmp28_);
		_g_free0 (_tmp28_);
		result = 0;
		_g_key_file_unref0 (default_config);
		args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
		return result;
	}
	_tmp29_ = vala_lint_application_lint_directory;
	if (_tmp29_ != NULL) {
		gchar** _tmp30_;
		gint _tmp30__length1;
		gint _tmp31_;
		gchar** _tmp32_;
		gint _tmp32__length1;
		gchar** _tmp33_;
		gint _tmp33__length1;
		const gchar* _tmp34_;
		gchar* _tmp35_;
		_tmp30_ = tmp;
		_tmp30__length1 = tmp_length1;
		_tmp31_ = _tmp30__length1 + 1;
		tmp = g_renew (gchar*, tmp, _tmp30__length1 + 1);
		(_tmp31_ > tmp_length1) ? memset (tmp + tmp_length1, 0, sizeof (gchar*) * (_tmp31_ - tmp_length1)) : NULL;
		tmp_length1 = _tmp31_;
		_tmp_size_ = _tmp31_;
		_tmp32_ = tmp;
		_tmp32__length1 = tmp_length1;
		_tmp33_ = tmp;
		_tmp33__length1 = tmp_length1;
		_tmp34_ = vala_lint_application_lint_directory;
		_tmp35_ = g_strdup (_tmp34_);
		_g_free0 (_tmp32_[_tmp33__length1 - 1]);
		_tmp32_[_tmp33__length1 - 1] = _tmp35_;
	}
	_tmp36_ = _g_object_ref0 (command_line);
	_g_object_unref0 (self->priv->application_command_line);
	self->priv->application_command_line = _tmp36_;
	_tmp37_ = g_direct_equal;
	_tmp38_ = vala_array_list_new (VALA_LINT_TYPE_FILE_DATA, (GBoxedCopyFunc) vala_lint_file_data_dup, (GDestroyNotify) vala_lint_file_data_free, _tmp37_);
	file_data_list = _tmp38_;
	{
		ValaArrayList* _tmp39_ = NULL;
		gchar** _tmp40_;
		gint _tmp40__length1;
		gchar** _tmp41_;
		gint _tmp41__length1;
		ValaArrayList* _tmp42_;
		ValaArrayList* _tmp43_;
		_tmp40_ = tmp;
		_tmp40__length1 = tmp_length1;
		_tmp41_ = tmp;
		_tmp41__length1 = tmp_length1;
		_tmp42_ = vala_lint_application_get_files (self, command_line, _tmp40_ + 1, (gint) (_tmp41__length1 - 1), &_inner_error0_);
		_tmp39_ = _tmp42_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch1_g_error;
		}
		_tmp43_ = _tmp39_;
		_tmp39_ = NULL;
		_vala_iterable_unref0 (file_data_list);
		file_data_list = _tmp43_;
		_vala_iterable_unref0 (_tmp39_);
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		gchar* _tmp44_;
		gchar* _tmp45_;
		GError* _tmp46_;
		const gchar* _tmp47_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp44_ = g_strconcat (_ ("Error: %s"), "\n", NULL);
		_tmp45_ = _tmp44_;
		_tmp46_ = e;
		_tmp47_ = _tmp46_->message;
		g_critical (_tmp45_, _tmp47_);
		_g_free0 (_tmp45_);
		_g_error_free0 (e);
	}
	__finally1:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gint _tmp48_ = -1;
		_vala_iterable_unref0 (file_data_list);
		args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp48_;
	}
	_tmp49_ = vala_lint_application_config_file;
	vala_lint_config_load_file (_tmp49_);
	_tmp50_ = vala_lint_linter_new ();
	linter = _tmp50_;
	{
		ValaArrayList* _data_list = NULL;
		ValaArrayList* _tmp51_;
		ValaArrayList* _tmp52_;
		gint _data_size = 0;
		ValaArrayList* _tmp53_;
		gint _tmp54_;
		gint _tmp55_;
		gint _data_index = 0;
		_tmp51_ = file_data_list;
		_tmp52_ = _vala_iterable_ref0 (_tmp51_);
		_data_list = _tmp52_;
		_tmp53_ = _data_list;
		_tmp54_ = vala_collection_get_size ((ValaCollection*) _tmp53_);
		_tmp55_ = _tmp54_;
		_data_size = _tmp55_;
		_data_index = -1;
		while (TRUE) {
			ValaLintFileData data = {0};
			ValaArrayList* _tmp56_;
			gpointer _tmp57_;
			ValaLintFileData* _tmp58_;
			ValaLintFileData _tmp59_;
			ValaLintFileData _tmp60_ = {0};
			ValaLintFileData _tmp61_;
			_data_index = _data_index + 1;
			if (!(_data_index < _data_size)) {
				break;
			}
			_tmp56_ = _data_list;
			_tmp57_ = vala_list_get ((ValaList*) _tmp56_, _data_index);
			_tmp58_ = (ValaLintFileData*) _tmp57_;
			_tmp59_ = *_tmp58_;
			vala_lint_file_data_copy (&_tmp59_, &_tmp60_);
			_tmp61_ = _tmp60_;
			_vala_lint_file_data_free0 (_tmp58_);
			data = _tmp61_;
			{
				ValaArrayList* mistakes = NULL;
				ValaLintLinter* _tmp62_;
				ValaLintFileData _tmp63_;
				GFile* _tmp64_;
				ValaArrayList* _tmp65_;
				ValaLintFileData _tmp66_;
				ValaArrayList* _tmp67_;
				ValaArrayList* _tmp68_;
				_tmp62_ = linter;
				_tmp63_ = data;
				_tmp64_ = _tmp63_.file;
				_tmp65_ = vala_lint_linter_run_checks_for_file (_tmp62_, _tmp64_, &_inner_error0_);
				mistakes = _tmp65_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					goto __catch2_g_error;
				}
				_tmp66_ = data;
				_tmp67_ = _tmp66_.mistakes;
				_tmp68_ = mistakes;
				vala_collection_add_all ((ValaCollection*) _tmp67_, (ValaCollection*) _tmp68_);
				_vala_iterable_unref0 (mistakes);
			}
			goto __finally2;
			__catch2_g_error:
			{
				GError* e = NULL;
				gchar* _tmp69_;
				gchar* _tmp70_;
				GError* _tmp71_;
				const gchar* _tmp72_;
				ValaLintFileData _tmp73_;
				GFile* _tmp74_;
				gchar* _tmp75_;
				gchar* _tmp76_;
				e = _inner_error0_;
				_inner_error0_ = NULL;
				_tmp69_ = g_strconcat (_ ("Error: %s while linting file %s"), "\n", NULL);
				_tmp70_ = _tmp69_;
				_tmp71_ = e;
				_tmp72_ = _tmp71_->message;
				_tmp73_ = data;
				_tmp74_ = _tmp73_.file;
				_tmp75_ = g_file_get_path (_tmp74_);
				_tmp76_ = _tmp75_;
				g_critical (_tmp70_, _tmp72_, _tmp76_);
				_g_free0 (_tmp76_);
				_g_free0 (_tmp70_);
				_g_error_free0 (e);
			}
			__finally2:
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				gint _tmp77_ = -1;
				vala_lint_file_data_destroy (&data);
				_vala_iterable_unref0 (_data_list);
				_g_object_unref0 (linter);
				_vala_iterable_unref0 (file_data_list);
				args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return _tmp77_;
			}
			vala_lint_file_data_destroy (&data);
		}
		_vala_iterable_unref0 (_data_list);
	}
	_tmp78_ = file_data_list;
	vala_lint_application_print_mistakes (self, _tmp78_);
	if (vala_lint_application_exit_with_zero) {
		result = 0;
		_g_object_unref0 (linter);
		_vala_iterable_unref0 (file_data_list);
		args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
		return result;
	}
	{
		ValaArrayList* _file_data_list = NULL;
		ValaArrayList* _tmp79_;
		ValaArrayList* _tmp80_;
		gint _file_data_size = 0;
		ValaArrayList* _tmp81_;
		gint _tmp82_;
		gint _tmp83_;
		gint _file_data_index = 0;
		_tmp79_ = file_data_list;
		_tmp80_ = _vala_iterable_ref0 (_tmp79_);
		_file_data_list = _tmp80_;
		_tmp81_ = _file_data_list;
		_tmp82_ = vala_collection_get_size ((ValaCollection*) _tmp81_);
		_tmp83_ = _tmp82_;
		_file_data_size = _tmp83_;
		_file_data_index = -1;
		while (TRUE) {
			ValaLintFileData file_data = {0};
			ValaArrayList* _tmp84_;
			gpointer _tmp85_;
			ValaLintFileData* _tmp86_;
			ValaLintFileData _tmp87_;
			ValaLintFileData _tmp88_ = {0};
			ValaLintFileData _tmp89_;
			_file_data_index = _file_data_index + 1;
			if (!(_file_data_index < _file_data_size)) {
				break;
			}
			_tmp84_ = _file_data_list;
			_tmp85_ = vala_list_get ((ValaList*) _tmp84_, _file_data_index);
			_tmp86_ = (ValaLintFileData*) _tmp85_;
			_tmp87_ = *_tmp86_;
			vala_lint_file_data_copy (&_tmp87_, &_tmp88_);
			_tmp89_ = _tmp88_;
			_vala_lint_file_data_free0 (_tmp86_);
			file_data = _tmp89_;
			{
				ValaArrayList* _mistake_list = NULL;
				ValaLintFileData _tmp90_;
				ValaArrayList* _tmp91_;
				ValaArrayList* _tmp92_;
				gint _mistake_size = 0;
				ValaArrayList* _tmp93_;
				gint _tmp94_;
				gint _tmp95_;
				gint _mistake_index = 0;
				_tmp90_ = file_data;
				_tmp91_ = _tmp90_.mistakes;
				_tmp92_ = _vala_iterable_ref0 (_tmp91_);
				_mistake_list = _tmp92_;
				_tmp93_ = _mistake_list;
				_tmp94_ = vala_collection_get_size ((ValaCollection*) _tmp93_);
				_tmp95_ = _tmp94_;
				_mistake_size = _tmp95_;
				_mistake_index = -1;
				while (TRUE) {
					ValaLintFormatMistake* mistake = NULL;
					ValaArrayList* _tmp96_;
					gpointer _tmp97_;
					ValaLintFormatMistake* _tmp98_;
					ValaLintCheck* _tmp99_;
					ValaLintConfigState _tmp100_;
					ValaLintConfigState _tmp101_;
					_mistake_index = _mistake_index + 1;
					if (!(_mistake_index < _mistake_size)) {
						break;
					}
					_tmp96_ = _mistake_list;
					_tmp97_ = vala_list_get ((ValaList*) _tmp96_, _mistake_index);
					mistake = (ValaLintFormatMistake*) _tmp97_;
					_tmp98_ = mistake;
					_tmp99_ = (*_tmp98_).check;
					_tmp100_ = vala_lint_check_get_state (_tmp99_);
					_tmp101_ = _tmp100_;
					if (_tmp101_ == VALA_LINT_CONFIG_STATE_ERROR) {
						result = 1;
						__vala_ValaLintFormatMistake_free0 (mistake);
						_vala_iterable_unref0 (_mistake_list);
						vala_lint_file_data_destroy (&file_data);
						_vala_iterable_unref0 (_file_data_list);
						_g_object_unref0 (linter);
						_vala_iterable_unref0 (file_data_list);
						args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
						return result;
					}
					__vala_ValaLintFormatMistake_free0 (mistake);
				}
				_vala_iterable_unref0 (_mistake_list);
			}
			vala_lint_file_data_destroy (&file_data);
		}
		_vala_iterable_unref0 (_file_data_list);
	}
	result = 0;
	_g_object_unref0 (linter);
	_vala_iterable_unref0 (file_data_list);
	args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
	return result;
}

static ValaLintFormatMistake*
_vala_lint_format_mistake_dup (ValaLintFormatMistake* self)
{
	ValaLintFormatMistake* dup;
	dup = g_new0 (ValaLintFormatMistake, 1);
	vala_lint_format_mistake_copy (self, dup);
	return dup;
}

static ValaArrayList*
vala_lint_application_get_files (ValaLintApplication* self,
                                 GApplicationCommandLine* command_line,
                                 gchar** patterns,
                                 gint patterns_length1,
                                 GError** error)
{
	ValaArrayList* _result_ = NULL;
	GEqualFunc _tmp0_;
	ValaArrayList* _tmp1_;
	GError* _inner_error0_ = NULL;
	ValaArrayList* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (command_line != NULL, NULL);
	_tmp0_ = g_direct_equal;
	_tmp1_ = vala_array_list_new (VALA_LINT_TYPE_FILE_DATA, (GBoxedCopyFunc) vala_lint_file_data_dup, (GDestroyNotify) vala_lint_file_data_free, _tmp0_);
	_result_ = _tmp1_;
	{
		gchar** pattern_collection = NULL;
		gint pattern_collection_length1 = 0;
		gint _pattern_collection_size_ = 0;
		gint pattern_it = 0;
		pattern_collection = patterns;
		pattern_collection_length1 = patterns_length1;
		for (pattern_it = 0; pattern_it < pattern_collection_length1; pattern_it = pattern_it + 1) {
			gchar* _tmp2_;
			gchar* pattern = NULL;
			_tmp2_ = g_strdup (pattern_collection[pattern_it]);
			pattern = _tmp2_;
			{
				glob_t matcher = {0};
				const gchar* _tmp3_;
				glob_t _tmp7_;
				gchar** _tmp8_;
				gint _tmp8__length1;
				memset (&matcher, 0, sizeof (glob_t));
				_tmp3_ = pattern;
				if (glob (_tmp3_, 0, NULL, &matcher) != 0) {
					gchar* _tmp4_;
					gchar* _tmp5_;
					const gchar* _tmp6_;
					_tmp4_ = g_strconcat (_ ("No files found for pattern: %s"), "\n", NULL);
					_tmp5_ = _tmp4_;
					_tmp6_ = pattern;
					g_application_command_line_print (command_line, _tmp5_, _tmp6_);
					_g_free0 (_tmp5_);
					globfree (&matcher);
					_g_free0 (pattern);
					continue;
				}
				_tmp7_ = matcher;
				_tmp8_ = _tmp7_.gl_pathv;
				_tmp8__length1 = _vala_array_length (_tmp7_.gl_pathv);
				{
					gchar** path_collection = NULL;
					gint path_collection_length1 = 0;
					gint _path_collection_size_ = 0;
					gint path_it = 0;
					path_collection = _tmp8_;
					path_collection_length1 = _tmp8__length1;
					for (path_it = 0; path_it < path_collection_length1; path_it = path_it + 1) {
						gchar* _tmp9_;
						gchar* path = NULL;
						_tmp9_ = g_strdup (path_collection[path_it]);
						path = _tmp9_;
						{
							GFile* file = NULL;
							const gchar* _tmp10_;
							GFile* _tmp11_;
							GFileType file_type = 0;
							GFile* _tmp12_;
							GFileType _tmp13_;
							_tmp10_ = path;
							_tmp11_ = g_file_new_for_path (_tmp10_);
							file = _tmp11_;
							_tmp12_ = file;
							file_type = g_file_query_file_type (_tmp12_, G_FILE_QUERY_INFO_NONE, NULL);
							_tmp13_ = file_type;
							switch (_tmp13_) {
								case G_FILE_TYPE_REGULAR:
								{
									ValaArrayList* _tmp14_;
									GFile* _tmp15_;
									const gchar* _tmp16_;
									GEqualFunc _tmp17_;
									ValaArrayList* _tmp18_;
									ValaArrayList* _tmp19_;
									ValaLintFileData _tmp20_ = {0};
									_tmp14_ = _result_;
									_tmp15_ = file;
									_tmp16_ = path;
									_tmp17_ = g_direct_equal;
									_tmp18_ = vala_array_list_new (VALA_LINT_TYPE_FORMAT_MISTAKE, (GBoxedCopyFunc) _vala_lint_format_mistake_dup, (GDestroyNotify) _vala_ValaLintFormatMistake_free, _tmp17_);
									_tmp19_ = _tmp18_;
									_g_object_unref0 (_tmp20_.file);
									_tmp20_.file = _tmp15_;
									_g_free0 (_tmp20_.name);
									_tmp20_.name = _tmp16_;
									_vala_iterable_unref0 (_tmp20_.mistakes);
									_tmp20_.mistakes = _tmp19_;
									vala_collection_add ((ValaCollection*) _tmp14_, &_tmp20_);
									_vala_iterable_unref0 (_tmp19_);
									break;
								}
								case G_FILE_TYPE_DIRECTORY:
								{
									ValaArrayList* _tmp21_ = NULL;
									GFile* _tmp22_;
									ValaArrayList* _tmp23_;
									_tmp22_ = file;
									_tmp23_ = vala_lint_application_get_files_from_directory (self, _tmp22_, &_inner_error0_);
									_tmp21_ = _tmp23_;
									if (G_UNLIKELY (_inner_error0_ != NULL)) {
										g_propagate_error (error, _inner_error0_);
										_g_object_unref0 (file);
										_g_free0 (path);
										globfree (&matcher);
										_g_free0 (pattern);
										_vala_iterable_unref0 (_result_);
										return NULL;
									}
									{
										ValaArrayList* _f_list = NULL;
										ValaArrayList* _tmp24_;
										gint _f_size = 0;
										ValaArrayList* _tmp25_;
										gint _tmp26_;
										gint _tmp27_;
										gint _f_index = 0;
										_tmp24_ = _vala_iterable_ref0 (_tmp21_);
										_f_list = _tmp24_;
										_tmp25_ = _f_list;
										_tmp26_ = vala_collection_get_size ((ValaCollection*) _tmp25_);
										_tmp27_ = _tmp26_;
										_f_size = _tmp27_;
										_f_index = -1;
										while (TRUE) {
											GFile* f = NULL;
											ValaArrayList* _tmp28_;
											gpointer _tmp29_;
											gchar* name = NULL;
											const gchar* _tmp30_;
											GFile* _tmp31_;
											GFile* _tmp32_;
											gchar* _tmp33_;
											gchar* _tmp34_;
											gchar* _tmp35_;
											gchar* _tmp36_;
											ValaArrayList* _tmp37_;
											GFile* _tmp38_;
											const gchar* _tmp39_;
											GEqualFunc _tmp40_;
											ValaArrayList* _tmp41_;
											ValaArrayList* _tmp42_;
											ValaLintFileData _tmp43_ = {0};
											_f_index = _f_index + 1;
											if (!(_f_index < _f_size)) {
												break;
											}
											_tmp28_ = _f_list;
											_tmp29_ = vala_list_get ((ValaList*) _tmp28_, _f_index);
											f = (GFile*) _tmp29_;
											_tmp30_ = path;
											_tmp31_ = file;
											_tmp32_ = f;
											_tmp33_ = g_file_get_relative_path (_tmp31_, _tmp32_);
											_tmp34_ = _tmp33_;
											_tmp35_ = g_strconcat (_tmp30_, _tmp34_, NULL);
											_tmp36_ = _tmp35_;
											_g_free0 (_tmp34_);
											name = _tmp36_;
											_tmp37_ = _result_;
											_tmp38_ = f;
											_tmp39_ = name;
											_tmp40_ = g_direct_equal;
											_tmp41_ = vala_array_list_new (VALA_LINT_TYPE_FORMAT_MISTAKE, (GBoxedCopyFunc) _vala_lint_format_mistake_dup, (GDestroyNotify) _vala_ValaLintFormatMistake_free, _tmp40_);
											_tmp42_ = _tmp41_;
											_g_object_unref0 (_tmp43_.file);
											_tmp43_.file = _tmp38_;
											_g_free0 (_tmp43_.name);
											_tmp43_.name = _tmp39_;
											_vala_iterable_unref0 (_tmp43_.mistakes);
											_tmp43_.mistakes = _tmp42_;
											vala_collection_add ((ValaCollection*) _tmp37_, &_tmp43_);
											_vala_iterable_unref0 (_tmp42_);
											_g_free0 (name);
											_g_object_unref0 (f);
										}
										_vala_iterable_unref0 (_f_list);
									}
									_vala_iterable_unref0 (_tmp21_);
									break;
								}
								default:
								{
									break;
								}
							}
							_g_object_unref0 (file);
							_g_free0 (path);
						}
					}
				}
				globfree (&matcher);
				_g_free0 (pattern);
			}
		}
	}
	result = _result_;
	return result;
}

static ValaArrayList*
vala_lint_application_get_files_from_directory (ValaLintApplication* self,
                                                GFile* dir,
                                                GError** error)
{
	ValaArrayList* files = NULL;
	GEqualFunc _tmp0_;
	ValaArrayList* _tmp1_;
	GFileEnumerator* enumerator = NULL;
	GFileEnumerator* _tmp2_;
	GFileInfo* info = NULL;
	GFileEnumerator* _tmp3_;
	GFileInfo* _tmp4_;
	GError* _inner_error0_ = NULL;
	ValaArrayList* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (dir != NULL, NULL);
	_tmp0_ = g_direct_equal;
	_tmp1_ = vala_array_list_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _tmp0_);
	files = _tmp1_;
	_tmp2_ = g_file_enumerate_children (dir, G_FILE_ATTRIBUTE_STANDARD_NAME, 0, NULL, &_inner_error0_);
	enumerator = _tmp2_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_vala_iterable_unref0 (files);
		return NULL;
	}
	_tmp3_ = enumerator;
	_tmp4_ = g_file_enumerator_next_file (_tmp3_, NULL, &_inner_error0_);
	info = _tmp4_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_object_unref0 (enumerator);
		_vala_iterable_unref0 (files);
		return NULL;
	}
	while (TRUE) {
		GFileInfo* _tmp5_;
		gchar* child_name = NULL;
		GFileInfo* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		GFile* child_file = NULL;
		const gchar* _tmp9_;
		GFile* _tmp10_;
		GFileInfo* _tmp11_;
		GFileInfo* _tmp21_ = NULL;
		GFileEnumerator* _tmp22_;
		GFileInfo* _tmp23_;
		GFileInfo* _tmp24_;
		_tmp5_ = info;
		if (!(_tmp5_ != NULL)) {
			break;
		}
		_tmp6_ = info;
		_tmp7_ = g_file_info_get_name (_tmp6_);
		_tmp8_ = g_strdup (_tmp7_);
		child_name = _tmp8_;
		_tmp9_ = child_name;
		_tmp10_ = g_file_resolve_relative_path (dir, _tmp9_);
		child_file = _tmp10_;
		_tmp11_ = info;
		if (g_file_info_get_file_type (_tmp11_) == G_FILE_TYPE_DIRECTORY) {
			GFileInfo* _tmp12_;
			_tmp12_ = info;
			if (!g_file_info_get_is_hidden (_tmp12_)) {
				ValaArrayList* sub_files = NULL;
				GFile* _tmp13_;
				ValaArrayList* _tmp14_;
				ValaArrayList* _tmp15_;
				ValaArrayList* _tmp16_;
				_tmp13_ = child_file;
				_tmp14_ = vala_lint_application_get_files_from_directory (self, _tmp13_, &_inner_error0_);
				sub_files = _tmp14_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					g_propagate_error (error, _inner_error0_);
					_g_object_unref0 (child_file);
					_g_free0 (child_name);
					_g_object_unref0 (info);
					_g_object_unref0 (enumerator);
					_vala_iterable_unref0 (files);
					return NULL;
				}
				_tmp15_ = files;
				_tmp16_ = sub_files;
				vala_collection_add_all ((ValaCollection*) _tmp15_, (ValaCollection*) _tmp16_);
				_vala_iterable_unref0 (sub_files);
			}
		} else {
			GFileInfo* _tmp17_;
			_tmp17_ = info;
			if (g_file_info_get_file_type (_tmp17_) == G_FILE_TYPE_REGULAR) {
				const gchar* _tmp18_;
				_tmp18_ = child_name;
				if (g_str_has_suffix (_tmp18_, ".vala")) {
					ValaArrayList* _tmp19_;
					GFile* _tmp20_;
					_tmp19_ = files;
					_tmp20_ = child_file;
					vala_collection_add ((ValaCollection*) _tmp19_, _tmp20_);
				}
			}
		}
		_tmp22_ = enumerator;
		_tmp23_ = g_file_enumerator_next_file (_tmp22_, NULL, &_inner_error0_);
		_tmp21_ = _tmp23_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_propagate_error (error, _inner_error0_);
			_g_object_unref0 (child_file);
			_g_free0 (child_name);
			_g_object_unref0 (info);
			_g_object_unref0 (enumerator);
			_vala_iterable_unref0 (files);
			return NULL;
		}
		_tmp24_ = _tmp21_;
		_tmp21_ = NULL;
		_g_object_unref0 (info);
		info = _tmp24_;
		_g_object_unref0 (_tmp21_);
		_g_object_unref0 (child_file);
		_g_free0 (child_name);
	}
	result = files;
	_g_object_unref0 (info);
	_g_object_unref0 (enumerator);
	return result;
}

static void
vala_lint_application_print_mistakes (ValaLintApplication* self,
                                      ValaArrayList* file_data_list)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (file_data_list != NULL);
	{
		ValaArrayList* _file_data_list = NULL;
		ValaArrayList* _tmp0_;
		gint _file_data_size = 0;
		ValaArrayList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _file_data_index = 0;
		_tmp0_ = _vala_iterable_ref0 (file_data_list);
		_file_data_list = _tmp0_;
		_tmp1_ = _file_data_list;
		_tmp2_ = vala_collection_get_size ((ValaCollection*) _tmp1_);
		_tmp3_ = _tmp2_;
		_file_data_size = _tmp3_;
		_file_data_index = -1;
		while (TRUE) {
			ValaLintFileData file_data = {0};
			ValaArrayList* _tmp4_;
			gpointer _tmp5_;
			ValaLintFileData* _tmp6_;
			ValaLintFileData _tmp7_;
			ValaLintFileData _tmp8_ = {0};
			ValaLintFileData _tmp9_;
			ValaLintFileData _tmp10_;
			ValaArrayList* _tmp11_;
			gboolean _tmp12_;
			gboolean _tmp13_;
			_file_data_index = _file_data_index + 1;
			if (!(_file_data_index < _file_data_size)) {
				break;
			}
			_tmp4_ = _file_data_list;
			_tmp5_ = vala_list_get ((ValaList*) _tmp4_, _file_data_index);
			_tmp6_ = (ValaLintFileData*) _tmp5_;
			_tmp7_ = *_tmp6_;
			vala_lint_file_data_copy (&_tmp7_, &_tmp8_);
			_tmp9_ = _tmp8_;
			_vala_lint_file_data_free0 (_tmp6_);
			file_data = _tmp9_;
			_tmp10_ = file_data;
			_tmp11_ = _tmp10_.mistakes;
			_tmp12_ = vala_collection_get_is_empty ((ValaCollection*) _tmp11_);
			_tmp13_ = _tmp12_;
			if (!_tmp13_) {
				GApplicationCommandLine* _tmp14_;
				ValaLintFileData _tmp15_;
				const gchar* _tmp16_;
				_tmp14_ = self->priv->application_command_line;
				_tmp15_ = file_data;
				_tmp16_ = _tmp15_.name;
				g_application_command_line_print (_tmp14_, "\x001b[1m\x001b[4m" "%s" "\x001b[0m\n", _tmp16_);
				{
					ValaArrayList* _mistake_list = NULL;
					ValaLintFileData _tmp17_;
					ValaArrayList* _tmp18_;
					ValaArrayList* _tmp19_;
					gint _mistake_size = 0;
					ValaArrayList* _tmp20_;
					gint _tmp21_;
					gint _tmp22_;
					gint _mistake_index = 0;
					_tmp17_ = file_data;
					_tmp18_ = _tmp17_.mistakes;
					_tmp19_ = _vala_iterable_ref0 (_tmp18_);
					_mistake_list = _tmp19_;
					_tmp20_ = _mistake_list;
					_tmp21_ = vala_collection_get_size ((ValaCollection*) _tmp20_);
					_tmp22_ = _tmp21_;
					_mistake_size = _tmp22_;
					_mistake_index = -1;
					while (TRUE) {
						ValaLintFormatMistake mistake = {0};
						ValaArrayList* _tmp23_;
						gpointer _tmp24_;
						ValaLintFormatMistake* _tmp25_;
						ValaLintFormatMistake _tmp26_;
						ValaLintFormatMistake _tmp27_ = {0};
						ValaLintFormatMistake _tmp28_;
						gchar* color_state = NULL;
						gchar* _tmp29_;
						gchar* mistakes_end = NULL;
						gchar* _tmp30_;
						ValaLintFormatMistake _tmp36_;
						ValaLintCheck* _tmp37_;
						ValaLintConfigState _tmp38_;
						ValaLintConfigState _tmp39_;
						GApplicationCommandLine* _tmp48_;
						const gchar* _tmp49_;
						gchar* _tmp50_;
						gchar* _tmp51_;
						gchar* _tmp52_;
						gchar* _tmp53_;
						ValaLintFormatMistake _tmp54_;
						ValaSourceLocation _tmp55_;
						ValaLintFormatMistake _tmp56_;
						ValaSourceLocation _tmp57_;
						const gchar* _tmp58_;
						ValaLintFormatMistake _tmp59_;
						ValaLintCheck* _tmp60_;
						ValaLintConfigState _tmp61_;
						ValaLintConfigState _tmp62_;
						gchar* _tmp63_;
						gchar* _tmp64_;
						ValaLintFormatMistake _tmp65_;
						const gchar* _tmp66_;
						ValaLintFormatMistake _tmp67_;
						ValaLintCheck* _tmp68_;
						const gchar* _tmp69_;
						const gchar* _tmp70_;
						_mistake_index = _mistake_index + 1;
						if (!(_mistake_index < _mistake_size)) {
							break;
						}
						_tmp23_ = _mistake_list;
						_tmp24_ = vala_list_get ((ValaList*) _tmp23_, _mistake_index);
						_tmp25_ = (ValaLintFormatMistake*) _tmp24_;
						_tmp26_ = *_tmp25_;
						vala_lint_format_mistake_copy (&_tmp26_, &_tmp27_);
						_tmp28_ = _tmp27_;
						__vala_ValaLintFormatMistake_free0 (_tmp25_);
						mistake = _tmp28_;
						_tmp29_ = g_strdup ("%-5s");
						color_state = _tmp29_;
						_tmp30_ = g_strdup ("");
						mistakes_end = _tmp30_;
						if (vala_lint_application_print_mistakes_end) {
							ValaLintFormatMistake _tmp31_;
							ValaSourceLocation _tmp32_;
							ValaLintFormatMistake _tmp33_;
							ValaSourceLocation _tmp34_;
							gchar* _tmp35_;
							_tmp31_ = mistake;
							_tmp32_ = _tmp31_.end;
							_tmp33_ = mistake;
							_tmp34_ = _tmp33_.end;
							_tmp35_ = g_strdup_printf ("-%5i.%-3i", _tmp32_.line, _tmp34_.column);
							_g_free0 (mistakes_end);
							mistakes_end = _tmp35_;
						}
						_tmp36_ = mistake;
						_tmp37_ = _tmp36_.check;
						_tmp38_ = vala_lint_check_get_state (_tmp37_);
						_tmp39_ = _tmp38_;
						switch (_tmp39_) {
							case VALA_LINT_CONFIG_STATE_ERROR:
							{
								const gchar* _tmp40_;
								gchar* _tmp41_;
								gchar* _tmp42_;
								gchar* _tmp43_;
								_tmp40_ = color_state;
								_tmp41_ = g_strconcat ("\033[1;31m", _tmp40_, NULL);
								_tmp42_ = _tmp41_;
								_tmp43_ = g_strconcat (_tmp42_, "\033[0m", NULL);
								_g_free0 (color_state);
								color_state = _tmp43_;
								_g_free0 (_tmp42_);
								break;
							}
							case VALA_LINT_CONFIG_STATE_WARN:
							{
								const gchar* _tmp44_;
								gchar* _tmp45_;
								gchar* _tmp46_;
								gchar* _tmp47_;
								_tmp44_ = color_state;
								_tmp45_ = g_strconcat ("\033[1;33m", _tmp44_, NULL);
								_tmp46_ = _tmp45_;
								_tmp47_ = g_strconcat (_tmp46_, "\033[0m", NULL);
								_g_free0 (color_state);
								color_state = _tmp47_;
								_g_free0 (_tmp46_);
								break;
							}
							default:
							{
								break;
							}
						}
						_tmp48_ = self->priv->application_command_line;
						_tmp49_ = color_state;
						_tmp50_ = g_strconcat ("\x001b[0m%5i.%-3i %s  ", _tmp49_, NULL);
						_tmp51_ = _tmp50_;
						_tmp52_ = g_strconcat (_tmp51_, "   %-45s   \033[2m%s\033[0m\n", NULL);
						_tmp53_ = _tmp52_;
						_tmp54_ = mistake;
						_tmp55_ = _tmp54_.begin;
						_tmp56_ = mistake;
						_tmp57_ = _tmp56_.begin;
						_tmp58_ = mistakes_end;
						_tmp59_ = mistake;
						_tmp60_ = _tmp59_.check;
						_tmp61_ = vala_lint_check_get_state (_tmp60_);
						_tmp62_ = _tmp61_;
						_tmp63_ = vala_lint_config_state_to_string (_tmp62_);
						_tmp64_ = _tmp63_;
						_tmp65_ = mistake;
						_tmp66_ = _tmp65_.mistake;
						_tmp67_ = mistake;
						_tmp68_ = _tmp67_.check;
						_tmp69_ = vala_lint_check_get_title (_tmp68_);
						_tmp70_ = _tmp69_;
						g_application_command_line_print (_tmp48_, _tmp53_, _tmp55_.line, _tmp57_.column, _tmp58_, _tmp64_, _tmp66_, _tmp70_);
						_g_free0 (_tmp64_);
						_g_free0 (_tmp53_);
						_g_free0 (_tmp51_);
						_g_free0 (mistakes_end);
						_g_free0 (color_state);
						vala_lint_format_mistake_destroy (&mistake);
					}
					_vala_iterable_unref0 (_mistake_list);
				}
			}
			vala_lint_file_data_destroy (&file_data);
		}
		_vala_iterable_unref0 (_file_data_list);
	}
}

gint
vala_lint_application_main (gchar** args,
                            gint args_length1)
{
	ValaLintApplication* _tmp0_;
	ValaLintApplication* _tmp1_;
	gint _tmp2_;
	gint result = 0;
	_tmp0_ = vala_lint_application_new ();
	_tmp1_ = _tmp0_;
	_tmp2_ = g_application_run ((GApplication*) _tmp1_, (gint) args_length1, args);
	_g_object_unref0 (_tmp1_);
	result = _tmp2_;
	return result;
}

int
main (int argc,
      char ** argv)
{
	return vala_lint_application_main (argv, argc);
}

static void
vala_lint_application_class_init (ValaLintApplicationClass * klass,
                                  gpointer klass_data)
{
	vala_lint_application_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &ValaLintApplication_private_offset);
	((GApplicationClass *) klass)->command_line = (gint (*) (GApplication*, GApplicationCommandLine*)) vala_lint_application_real_command_line;
	G_OBJECT_CLASS (klass)->finalize = vala_lint_application_finalize;
}

static void
vala_lint_application_instance_init (ValaLintApplication * self,
                                     gpointer klass)
{
	self->priv = vala_lint_application_get_instance_private (self);
}

static void
vala_lint_application_finalize (GObject * obj)
{
	ValaLintApplication * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VALA_LINT_TYPE_APPLICATION, ValaLintApplication);
	_g_object_unref0 (self->priv->application_command_line);
	G_OBJECT_CLASS (vala_lint_application_parent_class)->finalize (obj);
}

static GType
vala_lint_application_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ValaLintApplicationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vala_lint_application_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValaLintApplication), 0, (GInstanceInitFunc) vala_lint_application_instance_init, NULL };
	GType vala_lint_application_type_id;
	vala_lint_application_type_id = g_type_register_static (g_application_get_type (), "ValaLintApplication", &g_define_type_info, 0);
	ValaLintApplication_private_offset = g_type_add_instance_private (vala_lint_application_type_id, sizeof (ValaLintApplicationPrivate));
	return vala_lint_application_type_id;
}

GType
vala_lint_application_get_type (void)
{
	static volatile gsize vala_lint_application_type_id__volatile = 0;
	if (g_once_init_enter (&vala_lint_application_type_id__volatile)) {
		GType vala_lint_application_type_id;
		vala_lint_application_type_id = vala_lint_application_get_type_once ();
		g_once_init_leave (&vala_lint_application_type_id__volatile, vala_lint_application_type_id);
	}
	return vala_lint_application_type_id__volatile;
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gint i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	gint length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

